#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <sys/time.h>
#include <sys/resource.h>
#include <fcntl.h>
#include <unistd.h>
#include <errno.h>
#include <sys/time.h>
#include "../rti860/rti860.h"
#include <malloc.h>
#include <sys/mman.h>
#include <linux/unistd.h>
#include <linux/mman.h>

_syscall2(int, mlock, const void *, addr, size_t, len)
_syscall2(int, munlock, const void *, addr, size_t, len)
_syscall1(int, mlockall, int, how)
_syscall0(int, munlockall)

#define LEN 1000

short buf[LEN][4];

main()
{
  int file1, file2, ret;
  long i, j;
  Rti860 rti1, rti2;
  fd_set fds;
  struct timeval tv = { 0l, 0l };

/*  ret = mlock( buf, LEN*4*sizeof(short) );
  if( ret == -1 ) {
    perror(NULL);
    exit(1);
  }*/

  file1 = open( "/dev/rti860_320", O_RDONLY );

  if( file1 != -1 ) {
    ret = ioctl(file1,(unsigned int)RTI860_GET_PAR,(char *)&rti1);
    
    printf("%f %d %d\n",rti1.frequency,rti1.prescale,rti1.scale);

    rti1.frequency = 10000.0;
    rti1.channel = Channel1_4;
    rti1.irq = -1;
    rti1.timeout = tv;
    
    ret = ioctl(file1,(unsigned int)RTI860_SET_PAR,(char *)&rti1);
    if( ret == -1 ) {
      perror(NULL);
      exit(1);
    }

    ret = ioctl(file1,(unsigned int)RTI860_GET_PAR,(char *)&rti1);
    printf("%f %d %d\n",rti1.frequency,rti1.prescale,rti1.scale);

    FD_ZERO(&fds);
    FD_SET(file1,&fds);
    ret = select(16,&fds,NULL,NULL,&tv);
    printf("ret=%d %d %d\n",ret,FD_ISSET(file1,&fds),FD_ISSET(file2,&fds));

    for( i=0 ; i<1000 ; i++ ) {
      ret = read( file1, buf, LEN*4*sizeof(short) );
      printf("%d von %d Werte gelesen!\n",ret,LEN*4*sizeof(short));
      if( ret == -1 ) {
	perror(NULL);
	exit(1);
      }
    }
  }
  else {
    printf("Kann Datei nicht ffnen!\n");
    perror(NULL);
  }

  close(file1);
}
